module StarkitBanking
  module RBL
    module Account
      class GetBalance
        include ApiClient

        private

        def service_name
          'BALANCE ENQUIRY'
        end

        def invoke(env, req, callbacks)
          ApiBanking::GetAccountBalance.get_account_balance(env, req, callbacks)
        end

        def response(rep)
          rep.balanceAmount
        end

        def credentials(payment_account)
          payment_account.credentials
        end

        def request(subscription, payment_account)

          header = ApiBanking::GetAccountBalance::ReqHeader.new()
          reqBody = ApiBanking::GetAccountBalance::ReqBody.new()
          request = ApiBanking::GetAccountBalance::Request.new()

          header.corpID          = subscription.app_id
          header.approverID      = payment_account.created_by

          reqBody.accountNo = payment_account.account_number

          request.header = header
          request.body = reqBody

          request
        end

        def subscription(payment_account)
          payment_account.service_subscriptions.find_by(service_name: service_name)
        end

      end
    end
  end
end

