module StarkitBanking
  module YBL
    module Account
      class GetBalance
        include ApiClient

        private

        def service_name
          'BALANCE ENQUIRY'
        end

        def invoke(env, req, callbacks)
          ApiBanking::FundsTransferByCustomerService2.get_balance(env, req, callbacks)
        end

        def response(rep)
          Money.from_amount(rep.accountBalanceAmount, rep.accountCurrencyCode)
        end

        def credentials(payment_account)
          payment_account.credentials
        end

        def request(subscription, payment_account)

          request = ApiBanking::FundsTransferByCustomerService2::GetBalance::Request.new()

          request.appID = subscription.app_id
          request.customerID = payment_account.customer_id
          request.AccountNumber = payment_account.account_number

          request
        end

        def subscription(payment_account)
          payment_account.service_subscriptions.find_by(service_name: service_name)
        end

      end
    end
  end
end

