require 'active_support/concern'

module StarkitBanking
  module Payment
    extend ActiveSupport::Concern
    include ApiStepConcern

    def is_imt
      self.transfer_type == 'IMT'
    end

    def is_eft
      self.transfer_type != 'IMT'
    end

    def release(opts = {})
      self.payment_account.instance_variable_set(:@password, opts[:api_password])
      self.environment = self.payment_account.environment
      self.updated_by = opts[:current_user_id]
      self.approve
      self.reference_no = self.id
      self.response = StarkitBanking::API::Factory.get_client(self).exec(self)
    end

    def sync_status(opts = {})
      self.payment_account.instance_variable_set(:@password, opts[:api_password])
      self.response = StarkitBanking::API::Factory.get_client(self, 'GetStatus').exec(self)
    end
  end
end
